package dev.shadowsoffire.apotheosis.adventure.loot;

import java.util.function.Function;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.kinds.App;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import net.minecraftforge.common.loot.IGlobalLootModifier;
import it.unimi.dsi.fastutil.objects.ObjectListIterator;
import net.minecraft.util.RandomSource;
import java.util.Iterator;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.AdventureConfig;
import dev.shadowsoffire.apotheosis.Apotheosis;
import net.minecraft.world.level.storage.loot.LootContext;
import net.minecraft.world.item.ItemStack;
import it.unimi.dsi.fastutil.objects.ObjectArrayList;
import net.minecraft.world.level.storage.loot.predicates.LootItemCondition;
import com.mojang.serialization.Codec;
import net.minecraftforge.common.loot.LootModifier;

public class AffixConvertLootModifier extends LootModifier
{
    public static final Codec<AffixConvertLootModifier> CODEC;
    
    protected AffixConvertLootModifier(final LootItemCondition[] conditionsIn) {
        super(conditionsIn);
    }
    
    protected ObjectArrayList<ItemStack> doApply(final ObjectArrayList<ItemStack> generatedLoot, final LootContext context) {
        if (!Apotheosis.enableAdventure) {
            return generatedLoot;
        }
        for (final AdventureConfig.LootPatternMatcher m : AdventureConfig.AFFIX_CONVERT_LOOT_RULES) {
            if (m.matches(context.getQueriedLootTableId())) {
                final RarityClamp rarities = AdventureConfig.AFFIX_CONVERT_RARITIES.get(context.m_78952_().m_46472_().m_135782_());
                final RandomSource rand = context.m_230907_();
                final float luck = context.m_78945_();
                for (final ItemStack s : generatedLoot) {
                    if (!LootCategory.forItem(s).isNone() && AffixHelper.getAffixes(s).isEmpty() && rand.m_188501_() <= m.chance()) {
                        LootController.createLootItem(s, LootRarity.random(rand, luck, rarities), rand);
                    }
                }
                break;
            }
        }
        return generatedLoot;
    }
    
    public Codec<? extends IGlobalLootModifier> codec() {
        return (Codec<? extends IGlobalLootModifier>)AffixConvertLootModifier.CODEC;
    }
    
    static {
        CODEC = RecordCodecBuilder.create(inst -> codecStart(inst).apply((Applicative)inst, (Function)AffixConvertLootModifier::new));
    }
}
